//      (c) 1999 PEAK-System Technik

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>	/* wg. kbhit() etc. */
#include <time.h>

#include "can.h"

#define LPT_Port 0x378


/********************************************************************
 *  msg2text()
 *  Gibt die Textdarstellung einer CAN-Message zurueck.
 *  statischer Puffer!
 */

static char *msg2text( TCANMsg *msg)
{
	static char  txtbuff[255] ;
	char    buff[80] ;
	int     i ;

	sprintf(txtbuff, "ID=%x", msg->ID) ;

	if ( msg->RTR )
	{
		sprintf(buff, ", RTR, Len=%d", msg->LEN) ;
		strcat(txtbuff, buff) ;
	}
	else if (msg->LEN > 0)
	{
		strcat(txtbuff, ", Data(hex)=") ;
		for (i=0 ; i < msg->LEN ; i++)
		{
			sprintf(buff, "%0.2x ", msg->DATA[i]) ;
			strcat(txtbuff, buff) ;
		}
	}
	return txtbuff ;
}

static char *err2text( int error )
{
	static char  txtbuff[255] ;

	txtbuff[0] = '\0' ;
	if ( error & CAN_ERR_XMTFULL  ) strcat(txtbuff, "XMTFULL ") ;
	if ( error & CAN_ERR_OVERRUN  ) strcat(txtbuff, "OVERRUN ") ;
	if ( error & CAN_ERR_BUSERROR ) strcat(txtbuff, "BUSERROR ") ;
	if ( error & CAN_ERR_BUSOFF   ) strcat(txtbuff, "BUSOFF ") ;
	if ( error & CAN_ERR_RCVEMPTY ) strcat(txtbuff, "RCVEMPTY ") ;
	if ( error & CAN_ERR_REGTEST  ) strcat(txtbuff, "REGTEST ") ;
	if ( strlen(txtbuff) == 0)	strcat(txtbuff, "OK") ;

	return txtbuff ;
}


/* Zeit in Sekunden */
#define NOW	(clock() / CLK_TCK)

main()
{
	TCANMsg msg ;
	long    n ;
	int     err, old_err ;
	long    sendtime ;

	printf("\n\n *** CAN-Test beginnt ***\n") ;
	printf("Portadresse %x mit 500\n",LPT_Port) ;

	err = CAN_Init(LPT_Port, CAN_BAUD_500K) ;
	if ( err != CAN_ERR_OK )
	{
		printf("InitFehler: %s", err2text(err)) ;
		return 1 ;
	}

	n = 0 ;
	old_err = CAN_ERR_OK ;
	sendtime = NOW ;

	while ( ! kbhit() )
	{
		/* ---- 1) Lesen ---- */
		err = CAN_Read(&msg) ;
		if ( err == CAN_ERR_OK )
		{
			n++ ;
			printf("%3ld)  EMPFANG: %s\n", n, msg2text(&msg)) ;
		}
		else
		{	/* bei Fehler: nur Anzeige bei Wechsel */
			err = err & ~ CAN_ERR_RCVEMPTY ;
			/* RCVEMPTY ist kein Fehler */
			if ( err != old_err )
				printf("RcvFehler: %s", err2text(err)) ;
		}
		old_err = err ;

		/* ---- 2) was schreiben ---- */
		if ( sendtime < NOW )
		{
			msg.ID = 0x200 ;
			msg.RTR = 1 ;
			msg.LEN = 0 ;
			err = CAN_Write(&msg) ;
			if ( err != CAN_ERR_OK )
				printf("SendFehler: %s\n", err2text(err)) ;
			else
				printf("SEND 0x200\n") ;

			/* Jede Sekunde senden */
			sendtime = NOW + 1 ;
		}
	} /* while */
	printf("ENDE!\n") ;

	getch() ;	/* Friss Abbruchtaste */

	CAN_Close() ;

	printf("\n*** CAN-Test fertig ***\n\n") ;

	return 0 ;
}
