
#ifndef __HWPELICNH__           /* Schutz gegen mehrfaches #include */
#define __HWPELICNH__

/**********************************************************************
 *      hwpelicn.h
 *      Definition von Konstanten fr den SJA1000 im PeliCAN-Mode
 * 
     (c) 1999 PEAK-System Technik

 */

// Grundeigenschaften des SJA1000 im PeliCAN-Mode
#define HWPELICAN_CAPABILITIES (CAN_HWCAP_CAN20A | CAN_HWCAP_CAN20B\
        | CAN_HWCAP_LOOPBACK | CAN_HWCAP_LISTEN)

/*** Adressen im SJA 1000 CAN-Controller, PeliCAN-Mode ***/

#define REG_MODE            0
#define REG_COMMAND         1
#define REG_STATUS          2
#define REG_INTERRUPT       3
#define REG_IRQENABLE       4           // Interrupt Enable
#define REG_TIMING0         6           // Bus Timing 0
#define REG_TIMING1         7           // Bus Timing 1
#define REG_OUTPUTCTRL      8           // Output Control
#define REG_TEST            9

#define REG_ARBLOSTCAP     11           // Arbitration Lost Capture
#define REG_ERRCODECAP     12           // Error Code Capture
#define REG_ERRWARNLIMIT   13           // Error Warning Limit
#define REG_RXERRCOUNT     14           // Rx Error Counter
#define REG_TXERRCOUNT     15           // Tx Error Counter

/**** Rcv/Xmt-Buffer only in operation mode ****/
// read = Rx-Buffer, write = TxBuffer
#define REG_FRAMEINFO      16           // Frame format, RTR, data length
// SFF-Mode (standard frames)
#define REG_SFFID1         17           // bits 28..21 of ID
#define REG_SFFID2         18           // bits 20..18 of ID
#define REG_SFFDATA        19           // Begin of data buffer (8 bytes)
// EFF-Mode (extended frames)
#define REG_EFFID1         17           // bits 28..21 of ID
#define REG_EFFID2         18           // bits 20..13 of ID
#define REG_EFFID3         19           // bits 12..5 of ID
#define REG_EFFID4         20           // bits 4..0 of ID
#define REG_EFFDATA        21           // Begin of data buffer (8 bytes)

/**** Acceptance filter only in reset mode ****/
#define REG_ACCCODE0       16
#define REG_ACCCODE1       17
#define REG_ACCCODE2       18
#define REG_ACCCODE3       19
#define REG_ACCMASK0       20
#define REG_ACCMASK1       21
#define REG_ACCMASK2       22
#define REG_ACCMASK3       23

#define REG_RCVBUFSTART    30           // receive buffer start address
#define REG_CLOCKDIV       31           // Clock divider


#endif

