UNIT Cantdel1; 
  { Test der Unit CAN unter Windows/Delphi. }

  INTERFACE 

    USES 
      SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls, 
      Forms, Dialogs, StdCtrls, 
      can, ExtCtrls ; 

    TYPE 
      TForm1 = CLASS(TForm) 
          GroupBox1: TGroupBox; 
          GroupBox2: TGroupBox; 
          Label15: TLabel; 
          Label16: TLabel; 
          Label17: TLabel; 
          Label2: TLabel; 
          Label4: TLabel; 
          IDEdit: TEdit; 
          LenEdit: TEdit; 
          Data0Edit: TEdit; 
          Data1Edit: TEdit; 
          Data2Edit: TEdit; 
          Data3Edit: TEdit; 
          Data4Edit: TEdit; 
          Data5Edit: TEdit; 
          Data6Edit: TEdit; 
          Data7Edit: TEdit; 
          WriteButton: TButton; 
          SendPeriodEdit: TEdit; 
          GroupBox3: TGroupBox; 
          StartButton: TButton; 
          Label1: TLabel; 
          PortBaseEdit: TEdit; 
          Label3: TLabel; 
          Memo1: TMemo; 
          ClearButton: TButton; 
          ExitButton: TButton; 
          BaudCombo: TComboBox; 
          Label5: TLabel; 
          GroupBox4: TGroupBox; 
          ErrorLabel: TLabel; 
          Timer1: TTimer; 
          PROCEDURE FormShow(Sender: TObject); 
          PROCEDURE StartButtonClick(Sender: TObject); 
          PROCEDURE ExitButtonClick(Sender: TObject); 
          PROCEDURE FormCreate(Sender: TObject); 
          PROCEDURE Timer1Timer(Sender: TObject); 
          PROCEDURE ClearButtonClick(Sender: TObject); 
          PROCEDURE WriteButtonClick(Sender: TObject); 
        PRIVATE 
        { Private-Deklarationen }
        PUBLIC 
        { Public-Deklarationen }
          living : boolean ; { wenn CAN_Init() aufgerufen wurde }
          msgcount : longint ; 
          old_err : integer ; 
          sendtime : TDateTime ; 
          PROCEDURE AppIdle(Sender: TObject; VAR Done: Boolean); 
          PROCEDURE showstatus(info: string ; err: integer) ; 
          PROCEDURE rcvcheck ; 
          PROCEDURE sendcheck ; 
        END; 

    VAR 
      Form1: TForm1; 

  IMPLEMENTATION 

    {$R *.DFM}

    {************************************************************************
     *    HexB()
     *    HexW()
     *    Hexadezimal-Darstellung von Zahlen.
     *    *}
    CONST HexDigits : ARRAY[0..$F] OF Char = '0123456789ABCDEF'; 

    FUNCTION HexB(B : Byte) : string; 
      BEGIN 
        HexB[0] := #2; 
        HexB[1] := HexDigits[B shr 4]; 
        HexB[2] := HexDigits[B AND $F]; 
      END{ "HexB" } ; 

    FUNCTION HexW(W : Word) : string; 
      BEGIN 
        HexW[0] := #4; 
        HexW[1] := HexDigits[hi(W) shr 4]; 
        HexW[2] := HexDigits[hi(W) AND $F]; 
        HexW[3] := HexDigits[lo(W) shr 4]; 
        HexW[4] := HexDigits[lo(W) AND $F]; 
      END{ "HexW" } ; 

    {********************************************************************
     *      msg2text()
     *      gibt die Textdarstellung einer CAN-Message zurueck.
     *      *}
    FUNCTION msg2text( msg: TCANMsg ) : string ; 
      VAR 
        tmp, s : string ; 
        i : integer ; 
      BEGIN 
        s := 'ID=' + HexW(msg.ID) ; 

        IF ( msg.RTR ) THEN BEGIN 
              str(msg.LEN, tmp) ; 
              s := s + ', RTR, Len=' + tmp ; 
            END ELSE 
            IF (msg.LEN > 0) THEN BEGIN 
                  s := s + ' Data(hex)=' ; 
                  FOR i := 0 TO msg.LEN-1 DO 
                    s := s + hexb(msg.DATA[i])+ ' ' ; 
                END ; 
        msg2text := s ; 
      END { "msg2text" } ; 


    FUNCTION err2text( error: integer ) : string ; 
      VAR 
        s : string ; 
      BEGIN 
        s := '' ; 
        IF ( error AND CAN_ERR_XMTFULL  ) <> 0 THEN s := s + 'XMTFULL ' ; 
        IF ( error AND CAN_ERR_OVERRUN  ) <> 0 THEN s := s + 'OVERRUN ' ; 
        IF ( error AND CAN_ERR_BUSERROR ) <> 0 THEN s := s + 'BUSERROR ' ; 
        IF ( error AND CAN_ERR_BUSOFF   ) <> 0 THEN s := s + 'BUSOFF ' ; 
        IF ( error AND CAN_ERR_RCVEMPTY ) <> 0 THEN s := s + 'RCVEMPTY ' ; 
        IF ( error AND CAN_ERR_REGTEST  ) <> 0 THEN s := s + 'REGTEST ' ; 

        IF s = '' THEN s := 'OK' ; 
        err2text := s ; 
      END { "err2text" } ; 


    PROCEDURE TForm1.showstatus(info: string ; err : integer) ; 
      BEGIN 
        errorlabel.Caption := info+ ' ' + err2text(err) ; 
      END ; 

    PROCEDURE TForm1.rcvcheck ; 
    { Check, ob eine neue Message empfangen wurde }
      VAR 
        err : integer ; 
        msg : TCANMsg ; 
        s : string ; 
      BEGIN { "TForm1.rcvcheck" } 
        { hier den Empfang checken }
        err := CAN_Read(msg) ; 
        IF err = CAN_ERR_OK THEN BEGIN 
              msgcount := msgcount+1 ; 
              s := IntToStr(msgcount) + ')  ' + msg2text(msg) ; 
              IF Memo1.Lines.Count > 100 
                THEN Memo1.Lines.Clear ; 
              Memo1.Lines.Add(s) ; 
            END { then } ELSE BEGIN {* bei Fehler: nur Anzeige bei Wechsel *}
              err := err AND NOT CAN_ERR_RCVEMPTY ; 
              {* RCVEMPTY ist kein Fehler *}
              IF err <> old_err 
                THEN showstatus('Empfangsfehler: ', err) ; 
            END ; 
        old_err := err ; 
      END { "TForm1.rcvcheck" } ; 

    PROCEDURE TForm1.sendcheck ; 
    { checken, ob die Message gesendet werden mu }
      VAR 
        msg : TCANMsg ; 
        err : integer ; 
      BEGIN 
        IF ( sendtime < Now ) THEN BEGIN 
              TRY 
                msg.ID := StrToInt('$'+IDEDIT.Text) ; 
                msg.RTR := false ; { keine remote-request-Message schreiben }
                msg.LEN := StrToInt(LenEdit.Text) ; 
                msg.Data[0] := StrToInt('$' +  Data0Edit.text) ; 
                msg.Data[1] := StrToInt('$' +  Data1Edit.text) ; 
                msg.Data[2] := StrToInt('$' +  Data2Edit.text) ; 
                msg.Data[3] := StrToInt('$' +  Data3Edit.text) ; 
                msg.Data[4] := StrToInt('$' +  Data4Edit.text) ; 
                msg.Data[5] := StrToInt('$' +  Data5Edit.text) ; 
                msg.Data[6] := StrToInt('$' +  Data6Edit.text) ; 
                msg.Data[7] := StrToInt('$' +  Data7Edit.text) ; 
                err := CAN_Write(msg) ; 
                IF err <> CAN_ERR_OK 
                  THEN showstatus('SendFehler: ', err) ; 

                {* jede Sekunde senden *}
                sendtime := Now + StrToFloat(SendPeriodEdit.Text)/86400/1000 ; 
              EXCEPT 
                { bei Eingabefehler: nicht senden }
                showstatus('Eingabefehler', 0) ; 
              END ; 
            END { then } ; 
      END { "TForm1.sendcheck" } ; 


    PROCEDURE TForm1.FormCreate(Sender: TObject); 
      BEGIN 
        living := false ; 
        Application.OnIdle := AppIdle; 
      END; 

    PROCEDURE TForm1.FormShow(Sender: TObject); 
      BEGIN 
        ClearButton.Enabled := false ; 
        WriteButton.Enabled := false ; 
        BaudCombo.Items.Clear ; 
        BaudCombo.Items.Add('  1 MBit/s') ; 
        BaudCombo.Items.Add('500 kBit/s') ; 
        BaudCombo.Items.Add('250 kBit/s') ; 
        BaudCombo.Items.Add('125 kBit/s') ; 
        BaudCombo.Items.Add('100 kBit/s') ; 
        BaudCombo.Items.Add(' 50 kBit/s') ; 
        BaudCombo.Items.Add(' 20 kBit/s') ; 
        BaudCombo.Items.Add(' 10 kBit/s') ; 
        BaudCombo.Items.Add('  5 kBit/s') ; 
        { default: 500 k }
        BaudCombo.ItemIndex := 1 ; 
      END{ "TForm1.FormShow" } ; 

    PROCEDURE TForm1.StartButtonClick(Sender: TObject); 
      VAR 
        portbase : word ; 
        baud : word ; 
        err : integer ; 
      BEGIN 
        old_err := 0 ; 
        msgcount := 0 ; 
        sendtime := Now ; 
        { -- Es wurde Start gedrckt, nach Einstellung der Portadresse }
        PortBase := StrToInt('$' + PortBaseEdit.Text) ; 
        baud := 0 ; 
        IF BaudCombo.Text = '  1 MBit/s' THEN baud := CAN_BAUD_1M ; 
        IF BaudCombo.Text = '500 kBit/s' THEN baud := CAN_BAUD_500K ; 
        IF BaudCombo.Text = '250 kBit/s' THEN baud := CAN_BAUD_250K ; 
        IF BaudCombo.Text = '125 kBit/s' THEN baud := CAN_BAUD_125K ; 
        IF BaudCombo.Text = '100 kBit/s' THEN baud := CAN_BAUD_100K ; 
        IF BaudCombo.Text = ' 50 kBit/s' THEN baud := CAN_BAUD_50K ; 
        IF BaudCombo.Text = ' 20 kBit/s' THEN baud := CAN_BAUD_20K ; 
        IF BaudCombo.Text = ' 10 kBit/s' THEN baud := CAN_BAUD_10K ; 
        IF BaudCombo.Text = '  5 kBit/s' THEN baud := CAN_BAUD_5K ; 
        IF baud = 0 THEN BEGIN 
              baud := CAN_BAUD_500K ; 
              BaudCombo.ItemIndex := 1 ; 
            END ; 
        err := CAN_Init(portbase, baud) ; 
        IF err <> CAN_ERR_OK 
          THEN ShowStatus('Init:' , err) 
          ELSE BEGIN 
              StartButton.Enabled := false ; 
              PortBaseEdit.Enabled := false ; 
              BaudCombo.Enabled := false ; 
              WriteButton.Enabled := true ; 
              ClearButton.Enabled := true ; 
              living := true ; 
            END { else } ; 
      END{ "TForm1.StartButtonClick" } ; 

    PROCEDURE TForm1.ExitButtonClick(Sender: TObject); 
      BEGIN 
        Close ; 
        CAN_Close ; 
      END; 



    PROCEDURE TForm1.AppIdle(Sender: TObject; VAR Done: Boolean); 
      BEGIN 
        Done := True; 
        IF living THEN 
            BEGIN rcvcheck ; sendcheck ; rcvcheck ; sendcheck END ; 
      END; 


    PROCEDURE TForm1.Timer1Timer(Sender: TObject); 
      BEGIN 
        IF living THEN BEGIN 
              rcvcheck ; 
              sendcheck ; 
              rcvcheck ; 
              sendcheck ; 
            END ; 
      END{ "TForm1.Timer1Timer" } ; 

    PROCEDURE TForm1.ClearButtonClick(Sender: TObject); 
      BEGIN 
        Memo1.Lines.Clear ; 
      END; 

    PROCEDURE TForm1.WriteButtonClick(Sender: TObject); 
      BEGIN 
        { sofort senden }
        sendtime := now ; 
        sendcheck ; 
      END; 

  END{ "Cantdel1" } . 
