
UNIT IsaReg ; 

  {
     ISAREG.PAS
     Borland-Pascal / Delphi Unit zur Ansteuerung der
     Register des CAN-Controllers 82C200 auf der PEAK-ISA-CAN-Karte.


     Allgemeines zum CAN-Controller:
     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     Der CAN-Controller 82C200 besitzt 32 interne Register.
     Diese sind 0..31 nummeriert.
     Die 32 Register erscheinen an 32 aufeinanderfolgenden Adressen
     im IO-Adressbereich des PC's.
     Ein Schreiben nach Register 31 lst einen Hardwarereset
     des 82C200 aus, falls der entsprechende Jumper gesetzt ist.


     Copyright (C) 1996 by PEAK Service GmbH, Darmstadt.
  }

  INTERFACE 

    { bergabeparameter:
      'basisadr': Adresse der ISA-Karte (z.B. '0x300' fr die Defaultadresse).
      'reg_adr':  anzusprechendes Register im 82C200
                  (z.B. '2' fr das Statusregister).
      'reg_val':  in ein Register zu schreibender Wert.
    }

    { Schreib/Leseroutinen fuer den MUX-Modus }
    FUNCTION isa_regread(basisadr: word ; reg_adr : byte) : byte ; 
    PROCEDURE isa_regwrite(basisadr: word; reg_adr : byte ; reg_val : byte) ; 


  IMPLEMENTATION 

    FUNCTION isa_regread(basisadr: word ; reg_adr : byte) : byte ; 
      BEGIN 
        isa_regread := Port[basisadr + reg_adr] ;
      END ; 



    PROCEDURE isa_regwrite(basisadr: word; reg_adr : byte ; reg_val : byte) ; 
      BEGIN 
  	Port[basisadr + reg_adr] := reg_val ;
      END ; 

  END . 

