PROGRAM CanT ; 

  {  Ein kleines Testprogramm fr die Unit CAN.PAS.
     Zeigt alle empfangenen Messages an, und
     Sendet periodisch eine Message.
     (c) 1999 PEAK-System Technik  
     Sprache: Borland-Pascal 7.0 (DOS)
  }

  USES
    Crt, Dos, can ;

  {************************************************************************
   *    HexB()
   *    HexW()
   *    Hexadezimal-Darstellung von Zahlen.
   *    *}
  CONST HexDigits : ARRAY[0..$F] OF Char = '0123456789ABCDEF';

  FUNCTION HexB(B : Byte) : string;
    BEGIN
      HexB[0] := #2;
      HexB[1] := HexDigits[B shr 4];
      HexB[2] := HexDigits[B AND $F];
    END{ "HexB" } ;

  FUNCTION HexW(W : Word) : string;
    BEGIN
      HexW[0] := #4;
      HexW[1] := HexDigits[hi(W) shr 4];
      HexW[2] := HexDigits[hi(W) AND $F];
      HexW[3] := HexDigits[lo(W) shr 4];
      HexW[4] := HexDigits[lo(W) AND $F];
    END{ "HexW" } ; 

  {********************************************************************
   *      msg2text()
   *      gibt die Textdarstellung einer CAN-Message zurck.
   *      *}
  FUNCTION msg2text( msg: TCANMsg ) : string ; 
    VAR 
      tmp, s : string ; 
      i : integer ; 
    BEGIN 

      s := 'ID=' + HexW(msg.ID) ; 

      IF ( msg.RTR ) THEN BEGIN 
            str(msg.LEN, tmp) ; 
            s := s + ', RTR, Len=' + tmp ; 
          END ELSE 
          IF (msg.LEN > 0) THEN BEGIN 
                s := s + ' Data(hex)=' ; 
                FOR i := 0 TO msg.LEN-1 DO 
                  s := s + hexb(msg.DATA[i])+ ' ' ; 
              END ; 
      msg2text := s ; 
    END { "msg2text" } ; 


  FUNCTION err2text( error: integer ) : string ; 
    VAR 
      s : string ; 
    BEGIN 
      s := '' ; 
      IF ( error AND CAN_ERR_XMTFULL  ) <> 0 THEN s := s + 'XMTFULL ' ; 
      IF ( error AND CAN_ERR_OVERRUN  ) <> 0 THEN s := s + 'OVERRUN ' ; 
      IF ( error AND CAN_ERR_BUSERROR ) <> 0 THEN s := s + 'BUSERROR ' ; 
      IF ( error AND CAN_ERR_BUSOFF   ) <> 0 THEN s := s + 'BUSOFF ' ; 
      IF ( error AND CAN_ERR_RCVEMPTY ) <> 0 THEN s := s + 'RCVEMPTY ' ; 
      IF ( error AND CAN_ERR_REGTEST  ) <> 0 THEN s := s + 'REGTEST ' ; 

      IF s = '' THEN s := 'OK' ; 
      err2text := s ; 
    END { "err2text" } ; 


  {* Zeit in Sekunden seit Mitternacht *}
  FUNCTION Now : longint ; 
    VAR h, m, s, dummy : word ; 
    BEGIN 
      gettime(h, m, s, dummy) ; 
      now := h * 3600 + m * 60 + s ; 
    END ; 


  VAR 
    msg : TCANMsg ; 
    n : longint ; 
    err, old_err : integer ; 
    sendtime : longint ; 

  BEGIN { "CanT" } 
    writeln ; 
    writeln (' *** CAN-Test beginnt *** ') ; 
    writeln ; 

    err := CAN_Init($300, CAN_BAUD_500K) ; 
    IF ( err <> CAN_ERR_OK ) THEN BEGIN 
          writeln('InitFehler: ', err2text(err)) ; 
          halt(1) ; 
        END ; 

    n := 0 ; 
    old_err := CAN_ERR_OK ; 
    sendtime := Now ; 

    { der Test luft, bis irgendeine Taste gedrckt wird }
    WHILE NOT KeyPressed DO BEGIN 
        {* ---- 1) Lesen ---- *}
        err := CAN_Read(msg) ; 
        IF err = CAN_ERR_OK THEN BEGIN 
              n := n+1 ; 
              writeln(n:4, ')  EMPFANG: ', msg2text(msg)) ; 
            END ELSE BEGIN {* bei Fehler: nur Anzeige bei Wechsel *}
              err := err AND NOT CAN_ERR_RCVEMPTY ; 
              {* RCVEMPTY ist kein Fehler *}
              IF err <> old_err 
                THEN writeln('RcvFehler: ', err2text(err)) ; 
            END ; 
        old_err := err ; 

        {* ---- 2) was schreiben ---- *}
        IF ( sendtime < NOW ) THEN BEGIN 
              msg.ID := $200 ; 
              msg.RTR := true ; { remote-request-Message schreiben }
              msg.LEN := 0 ; 
              err := CAN_Write(msg) ; 
              IF err <> CAN_ERR_OK 
                THEN writeln('SendFehler: ', err2text(err)) 
                ELSE writeln('SEND Msg $200') ; 

              {* jede Sekunde senden *}
              sendtime := NOW + 1 ; 
            END { then } ; 
      END { while } ; 
    writeln('ENDE!') ; 

    ReadKey ;       {* friss die Abbruchtaste *}

    CAN_Close ; 

    writeln ; 
    writeln ('*** CAN-Test fertig ***') ; 
    writeln ; 
  END { "CanT" } . 
